/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 20 dec. 2006 10:35:22

import org.cocktail.carambole.server.MyComponent;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.finder.FinderUtilisateur;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOIndividu;
import org.cocktail.fwkcktldepense.server.metier.EOUtilisateur;
import org.cocktail.fwkcktldepense.server.process.ProcessCommande;
import org.cocktail.fwkcktlwebapp.common.CktlLog;
import org.cocktail.fwkcktlwebapp.common.database.CktlUserInfoDB;
import org.cocktail.fwkcktlwebapp.server.CktlMailBus;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eoaccess.EOUtilities;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSMutableArray;

public class Informer extends MyComponent {
	private static final long serialVersionUID = 1L;
	private EOCommande commande = null;
	private String emailFrom = null;
	private String emailsTo = null;
	private String emailSubject = null;
	private String emailMessage = null;
	private NSArray<EOUtilisateur> utilisateurs = null;
	public EOUtilisateur unUtilisateur = null;
	//private String filterDestinataires = null;
	private NSArray<EOUtilisateur> lesUtilisateursSelectionnes = null;
	private String observations = null;
	private boolean isEnCoursDeModification = false;

	public Informer(WOContext context) {
		super(context);
	}

	public WOComponent neFaitRien() {
		isEnCoursDeModification = false;
		return null;
	}

	public NSArray<EOUtilisateur> utilisateurs() {
		if (commande != null && utilisateurs == null) {
			EOEditingContext edc = commande.editingContext();
			utilisateurs = FinderUtilisateur.getUtilisateurs(edc, utilisateurInContext(edc), commande, NSArray.emptyArray());
		}

		return utilisateurs;
	}

	public String getEmailFrom() {
		if (emailFrom == null && commande != null) {
			CktlUserInfoDB utilisateurInfos = new CktlUserInfoDB(session.dataBus());
			EOUtilisateur utilisateur = utilisateurInContext(commande.editingContext());
			EOIndividu individu = utilisateur.individu();
			Integer noIndividu = (Integer) EOUtilities.primaryKeyForObject(individu.editingContext(), individu).allValues().lastObject();
			utilisateurInfos.individuForNoIndividu(noIndividu, true);
			emailFrom = utilisateurInfos.email();
		}
		return emailFrom;
	}

	public void setEmailFrom(String emailFrom) {
		this.emailFrom = emailFrom;
	}

	public String getEmailMessage() {
		// emailMessage = "";
		if (commande != null && (emailMessage == null || emailMessage.length() == 0)) {
			EOEditingContext edc = commande.editingContext();
			EOUtilisateur utilisateur = utilisateurInContext(edc);
			emailMessage = "La ";
			if (commande.typeEtat().tyetLibelle().equals(EOCommande.ETAT_PRECOMMANDE)) {
				emailMessage += "PRE-COMMANDE nº";
			}
			else {
				emailMessage += "COMMANDE nº";
			}
			emailMessage += commande.commNumero();
			emailMessage += " vient d'être enregistrée par ";
			emailMessage += utilisateur.individu().prenom();
			emailMessage += " " + utilisateur.individu().nomUsuel() + ".";
			emailMessage += "\n\nJe vous prie de bien vouloir la poursuivre.";
			emailMessage += "\n\nMerci.";

			emailMessage += "\n\n" + myApp().getApplicationURL(mySession().context()) + "/wa/DAConsultCommande?commId=" + commande.primaryKey();

			if (getObservations() != null) {
				emailMessage += "\n\nObservations supplémentaires:\n" + getObservations();
			}
		}

		return emailMessage;
	}

	public void setEmailMessage(String emailMessage) {
		if (!isEnCoursDeModification) {
			this.emailMessage = emailMessage;
		}
	}

	public String getEmailsTo() {
		NSArray<EOUtilisateur> lesUtilisateurs = getLesUtilisateursSelectionnes();

		if (lesUtilisateurs != null) {
			NSMutableArray<String> emails = new NSMutableArray<String>();
			CktlUserInfoDB utilisateurInfos = new CktlUserInfoDB(session.dataBus());
			for (int i = 0; i < lesUtilisateurs.count(); i++) {
				EOUtilisateur utilisateur = (EOUtilisateur) lesUtilisateurs.objectAtIndex(i);
				EOIndividu individu = utilisateur.individu();
				Integer noIndividu = (Integer) EOUtilities.primaryKeyForObject(individu.editingContext(), individu).allValues().lastObject();
				utilisateurInfos.individuForNoIndividu(noIndividu, true);
				if (utilisateurInfos.email() != null) {
					emails.addObject(utilisateurInfos.email());
				}
			}
			emailsTo = emails.componentsJoinedByString(", ");
		}
		return emailsTo;
	}

	public void setEmailsTo(String emailsTo) {
		this.emailsTo = emailsTo;
	}

	public String getEmailSubject() {
		if (emailSubject == null && commande != null) {
			emailSubject = "[CARAMBOLE]: Informations sur la ";
			if (commande.typeEtat().tyetLibelle().equals(EOCommande.ETAT_PRECOMMANDE)) {
				emailSubject += "PRE-COMMANDE nº";
			}
			else {
				emailSubject += "COMMANDE nº";
			}
			emailSubject += commande.commNumero();
		}
		return emailSubject;
	}

	public void setEmailSubject(String emailSubject) {
		this.emailSubject = emailSubject;
	}

	public NSArray<EOUtilisateur> getLesUtilisateursSelectionnes() {
		return lesUtilisateursSelectionnes;
	}

	public void setLesUtilisateursSelectionnes(NSArray<EOUtilisateur> lesUtilisateursSelectionnes) {
		this.lesUtilisateursSelectionnes = lesUtilisateursSelectionnes;
	}

	public String getObservations() {
		return observations;
	}

	public void setObservations(String observations) {
		this.observations = observations;
		String message = getEmailMessage();
		if (message != null && observations != null && observations.length() > 0) {
			int beginIndex = message.indexOf("Observations supplémentaires:");
			if (beginIndex > -1) {
				message = message.substring(beginIndex + 30);
			}
			else {
				message += "\n\nObservations supplémentaires:\n";
			}
			message += observations;
		}
		emailMessage = message;
		isEnCoursDeModification = true;
	}

	public WOComponent annuler() {
		DetailCommande nextPage = null;

		nextPage = (DetailCommande) pageWithName("DetailCommande");
		nextPage.setLaCommande(commande);
		reset();
		// session.setItemsMenu(DetailCommande.itemsMenu());

		return nextPage;

	}

	//    public void annuler() {
	//    	reset();
	//    }
	public boolean isEnvoyerDisabled() {
		boolean isEnvoyerDisabled = true;
		if (commande != null) {
			String from = getEmailFrom();
			String to = getEmailsTo();
			String sujet = getEmailSubject();
			if (from != null && !from.equals("") &&
					to != null && !to.equals("") &&
					sujet != null && !sujet.equals("")) {
				isEnvoyerDisabled = false;
			}
		}
		return isEnvoyerDisabled;
	}

	public WOComponent envoyer() {
		WOComponent nextPage = null;
		/*
		 * ERMailDeliveryPlainText mail = new ERMailDeliveryPlainText ();
		 * 
		 * try { mail.newMail(); mail.setTextContent (getEmailMessage()); mail.setFromAddress (getEmailFrom(), getEmailNomPrenomFrom()); //
		 * mail.setReplyToAddress ("jefyco2007@univ-lr.fr"); mail.setToAddresses(NSArray.componentsSeparatedByString(getEmailsTo(), ", "));
		 * mail.setBCCAddresses(new NSArray(getEmailFrom())); mail.setSubject(getEmailSubject()); mail.sendMail(); reset(); } catch (Exception e) {
		 * e.printStackTrace (); }
		 */
		try {
			ProcessCommande.insererUtilisateursContactes(session.dataBus(), commande, getLesUtilisateursSelectionnes());
			CktlMailBus cmb = session.mailBus();
			CktlLog.log("SMTP serveur:" + myApp().config().stringForKey("GRHUM_HOST_MAIL"));
			// L'adresse du serveur mail
			// tring smtpHost = myApp().config().stringForKey("GRHUM_HOST_MAIL");
			// On construit un message un indiquant le serveur mail
			// CktlMailMessage mailMessage = new CktlMailMessage(smtpHost);
			String destinataires = getEmailsTo();
			String message = getEmailMessage();

			if (myApp().config().booleanForKey("TEST") == true) {
				String message1 = "Application en test.\n";
				message1 += "Ce message avait normalement pour destinataire(s):\n";
				message1 += destinataires + "\n\n";
				message = message1 + message;
				destinataires = myApp().config().stringForKey("APP_ADMIN_MAIL");
				if (destinataires == null || destinataires.equals("")) {
					throw new FactoryException("Veuillez définiri le parametre APP_ADMIN_MAIL dans le fichier de config (redirection des mails).");
				}
			}
			cmb.sendMail(getEmailFrom(), destinataires, getEmailFrom(), getEmailSubject(), message);
			nextPage = (DetailCommande) pageWithName("DetailCommande");
			((DetailCommande) nextPage).setLaCommande(commande);
			// session.setItemsMenu(DetailCommande.itemsMenu());
		} catch (FactoryException e) {
			String alertMessage = e.getMessageFormatte();
			if (e.isBloquant()) {
				nextPage = (Informer) session.getSavedPageWithName("Informer");
				((Informer) nextPage).setCommande(commande);
				if (e.isInformatif()) {
					// Exception contenant un message d'information pour l'utilisateur
					session.setAlertMessage(alertMessage);
				}
				else {
					e.printStackTrace();
					throw e;
				}
			}
			else {
				session.setAlertMessage(alertMessage);
				nextPage = (DetailCommande) pageWithName("DetailCommande");
				((DetailCommande) nextPage).setLaCommande(commande);
				// session.setItemsMenu(DetailCommande.itemsMenu());
			}
		}
		return nextPage;
	}

	public void reset() {
		commande = null;
		emailFrom = null;
		emailsTo = null;
		emailSubject = null;
		emailMessage = null;
		unUtilisateur = null;
		//filterDestinataires = null;
		lesUtilisateursSelectionnes = null;
		observations = null;
	}

	public EOCommande getCommande() {
		return commande;
	}

	public void setCommande(EOCommande commande) {
		this.commande = commande;
	}

}